package PVE::HTMLGrid;

use strict;

sub new {
    my ($type, @wa) = @_;

    my $self = {};

    $self->{rowcount} = 0;
    $self->{colums} = scalar (@wa);
    $self->{data} = [];

    my @awidth;
    my @aalign;
    foreach my $wd (@wa) {
	my ($w, $align) = split (/:/, $wd);
	push @awidth, $w;
	push @aalign, $align;
    }

    $self->{widths} = [ @awidth ];
    $self->{aligns} = [ @aalign ];


    bless($self);
	
    return $self;
}

sub add_row {
    my ($self, @cols) = @_;

    push @{$self->{data}}, [ @cols ];
}

sub html {
    my ($self) = @_;

    my $out = "<table  border=0 cellspacing=0 cellpadding=2>";
    my $widths = $self->{widths};
    my $aligns = $self->{aligns};
    for (my $i = 0; $i < $self->{colums}; $i++) {
	$out .= "<COL width='@$widths[$i]'>";
    }

    foreach my $ca (@{$self->{data}}) {
	$out .= "<tr>";

	for (my $i = 0; $i < $self->{colums}; $i++) {

	    my $align = @$aligns[$i] ? "align='@$aligns[$i]'" : '';
	    $out .= "<td $align>@$ca[$i]</td>"
	}
	
	$out .= "</tr>";
    }
    $out .= "</table>";

    return $out;
}

1;
