package PVE::HTMLTable;

use strict;
use vars qw(@ISA);

sub new {
	my ($type, $width) = @_;

	my $self = {};

	$self->{rowcount} = 0;
	$self->{link_edit} = '';
	$self->{width} = $width;
	bless($self);
	
	return $self;
}
sub link_edit {
	my ($self, $v) = @_;
	if (defined($v)) {
		$self->{link_edit} = $v;
	}
	$self->{link_edit};
}

sub add_headline {
	my ($self,$headinfo) = @_;
	$self->{headline} = $headinfo;
}

sub set_param {
	my ($self, $v) = @_;
	if (defined($v)) {
		$self->{rowdata}->{$self->{rowcount}}->{param} = $self->{rowdata}->{$self->{rowcount}}->{param} . "&" . $v;
	}
	return "";
}
sub get_param {
	my ($self, $row) = @_;
	if (defined($row)) {
		return $self->{rowdata}->{$row}->{param};
	} else {
		return "";
	}	
}
sub set_row_link {
	my ($self,$lnk,$row) = @_;
	my $i;
	if (!(defined($row))) { $row = $self->{rowcount}; }
	$self->{rowdata}->{$row}->{lnk} = $lnk;
	return $self;
}

sub set_col_span {
        my ($self,$span,$row) = @_;
        if (!(defined($row))) { $row = $self->{rowcount}; }
        $self->{rowdata}->{$row}->{span} = $span;
        return $self;
}

sub set_row_js_onMouseOver {
	my ($self,$js,$row) = @_;
	my $i;
	if (!(defined($row))) { $row = $self->{rowcount}; }
	$self->{rowdata}->{$row}->{js_onMouseOver} = $js;
	return $self;
}
sub set_row_js_onMouseOut {
	my ($self,$js,$row) = @_;
	my $i;
	if (!(defined($row))) { $row = $self->{rowcount}; }
	$self->{rowdata}->{$row}->{js_onMouseOut} = $js;
	return $self;
}
sub add_row {
	my ($self,$id,@row) = @_;
	my $i;
	
	$self->{rowdata}->{$self->{rowcount}}->{len} = $#row;
	$self->{rowdata}->{$self->{rowcount}}->{id}  = $id;
	
	for $i (0 .. $#row)  {
		$self->{rowdata}->{$self->{rowcount}}->{"$i"} = $row[$i]; 
	}
	$self->{rowcount} = $self->{rowcount} + 1;
	return $self;
}

sub out_header {
	my ($self,$width) = @_;
	if (!(defined($width))) { $width='100%'; }
	my $htmlout = "";
	$htmlout = $htmlout . "<table border=0 cellspacing=0 cellpadding=3 style='margin:0px; padding:0px; width:".$width.";'>";
	return $htmlout;	
}

sub out_headline {
	my ($self) = @_;

	return "" if !$self->{headline};

	my @headinfo = @{$self->{headline}};
	my $i;
	my $htmlout = "";
	
	$htmlout = $htmlout . "<tr>";
	for $i (0 .. ($#headinfo/3)) {
	
	    $htmlout = $htmlout . "<td class='htmltable' colspan=" . $headinfo[$i*3] . 
		" style='width:".$headinfo[($i*3)+1].";'>".$headinfo[($i*3)+2]."</td>";
	}
	$htmlout = $htmlout . "</tr>";
	return $htmlout;
}


sub out_footer {
	my ($self) = @_;
	my $htmlout = "";
	$htmlout = $htmlout . "</table>";	
	return $htmlout;
}

sub out_celldata {
	my ($self,$row,$col) = @_;
	my $data = $self->{rowdata}->{"$row"}->{"$col"};
	return $data;
}

sub out_table {
	my ($self,$width, $sel) = @_;
	
	my $htmlout = "";
	my ($i,$c,$class,$col,$lnk);
	my $col1 = "#EDEDED";
	my $col2 = "#FFFFFF";
	my @width 	= @{$self->{width}};
	
	# Tableheader
	$htmlout = $htmlout . $self->out_header($width);
	
	# Tableheadline
	$htmlout = $htmlout . $self->out_headline ();
	
	#Tablecontent
	for $i (0 .. ($self->{rowcount}-1)) {
		if ($i % 2 == 0)	{ $class = 'htmltablerow1'; $col=$col1;}
		else				{ $class = 'htmltablerow2'; $col=$col2;}
		$col = "#FFF3BF" if defined ($sel) && $sel == $i;
		my $rid =  $self->{rowdata}->{$i}->{id};
		$rid = $rid ? "id='$rid'" : '';

		if (defined($self->{rowdata}->{$i}->{lnk})) {
		    $lnk = " onClick='goTo(\"".$self->{rowdata}->{$i}->{lnk}."\");'";
		    $htmlout = $htmlout . "<tr $rid $lnk style='background-color:".$col."; cursor:pointer;'";
		} else {
		    $htmlout = $htmlout . "<tr $rid style='background-color:".$col.";' ";
		}
		$htmlout = $htmlout . " onMouseover='this.style.backgroundColor=\"#FFF3BF\";  ". ($self->{rowdata}->{$i}->{js_onMouseOver} || '') ."'"; 
		$htmlout = $htmlout . " onMouseout ='this.style.backgroundColor=\"".$col."\"; ". ($self->{rowdata}->{$i}->{js_onMouseOut} || '') ."'";
		$htmlout = $htmlout . " >";
		
		my $span = $self->{rowdata}->{$i}->{span};
		for ($c = 0; $c <= $self->{rowdata}->{"$i"}->{len}; $c++)	{
		    my $sw = "";
		    if (defined ($span) && (@$span[$c] > 1)) {
			$sw = "colspan=@$span[$c]";
		    }
		    my $wtxt = $width[$c] ? "width:$width[$c];" : '';
		    $htmlout = $htmlout . "<td $sw class='".$class."' style='$wtxt' " . 
			" valign='top' align='left'>".$self->out_celldata($i,$c)."</td>";
		    
		    $c += @$span[$c] - 1 if $sw;
		}
		$htmlout = $htmlout . "</tr>\n";
	}
	
	# Tablefooter
	$htmlout = $htmlout . $self->out_footer();
	return $htmlout;
}

1;
