package PVE::I18N;

use strict;
require Exporter;
use vars qw(@ISA @EXPORT);
use Encode;
use HTML::Entities;
use Locale::Messages qw (textdomain bindtextdomain gettext);

@ISA = qw(Exporter);
@EXPORT = qw( __ );

my $nlsinited;
my $language = 'C';

sub get_lang {
    
    my $section = 'default';
    my $lang = 'C';

    open (SYSCFG, "</etc/pve/pve.cfg") || return $lang;
    while (my $line = <SYSCFG>) {
	chomp $line;
	if ($line =~ m/\s*language\s*:\s*(\S+)\s*$/) {
	    $lang = $1;
	    last;
	}
    } 
    close (SYSCFG);

    return $lang;
}

sub set_lang {
    my $lang = shift;

    $language = $lang;

}

if (!$nlsinited) {

    set_lang (get_lang);

    textdomain ("pve-manager");
    bindtextdomain ("pve-manager");

    $nlsinited = 1;
}

sub __ { 
    my $msgid = shift;
    my $oldlang = $ENV{LANGUAGE};
    my $oldlc_all = $ENV{LC_ALL};
    $ENV{LANGUAGE} = $language;
    my $res = &gettext($msgid); 
    $res = decode('UTF-8', $res) if scalar (grep { $language eq $_ } qw (ja hu ro ru fr tr zh_CN sr cs));
    $ENV{LANGUAGE} = $oldlang || '';
    $ENV{LC_ALL} = $oldlc_all || '';
    $res = encode_entities ($res);
    $res =~ s/&gt;/>/g;
    $res =~ s/&lt;/</g;
    $res =~ s/&\#39;/\'/g;
    return $res;
}

