package PVE::SafeSyslog;

use strict;
use warnings;
use Sys::Syslog ();

use vars qw($VERSION @ISA @EXPORT);

$VERSION = '1.00';

require Exporter;

@ISA = qw(Exporter);

@EXPORT = qw(syslog initlog);
 
# never log to console - thats too slow, and
# it corrupts the DBD database connection!

sub syslog {
    eval { Sys::Syslog::syslog (@_); }; # ignore errors
}

sub initlog {
    my ($ident, $facility) = @_;

    # never log to console - thats too slow
    Sys::Syslog::setlogsock ('unix');

    Sys::Syslog::openlog ($ident, 'pid', $facility);
}

1;
