#!/usr/bin/perl -w

use strict;
use CGI '3.12';
use mod_perl2 '1.9922';
use PVE::pvecfg;
use PVE::I18N;
use PVE::Config;
use HTML::Entities;
use Encode;

my $r = Apache2::RequestUtil->request();

my $pvever = PVE::pvecfg::version();

my $pvecfg = PVE::Config::read_file ('pvecfg');
my $language = $pvecfg->{language} || 'C';
PVE::I18N::set_lang ($language);

sub send_output {
    my ($r, $form) = @_;

    $form = encode('UTF-8', $form);
    $r->no_cache (1);
    my $x = length ($form);
    $r->content_type ("text/html;charset=UTF-8");
    $r->headers_out->set ("Content-length", "$x");
    $r->headers_out->set ("Pragma", "no-cache");

    $r->print ($form);
}

# check if someone opens us directly
if (!$r->prev) {
    send_output ($r, "<p>do not call me directly</p>");
    exit (0);
}

my $uri = $r->prev->uri;
if (my $vminfo = $r->prev->pnotes("PVE_VMINFO")) {
    $uri = $vminfo->{uri};
}

# if there are args, append that to the uri
my $args = $r->prev->args;
if ($args) {
    $uri .= "?$args";
}

my $reason = $r->prev->subprocess_env("AuthCookieReason");

my $errordoc = '';

if ($reason && $reason eq 'bad_credentials') {
    my $cgi = CGI->new($r);
    my %arghash =  $cgi->Vars();
    my $autologin = $arghash{credential_0} &&  $arghash{credential_0} eq '_autologin_';

    my $txt;

    if ($autologin) {
	$txt = __("You could not be logged on. Ticket is no longer valid.");
    } else {
	$txt = __("You could not be logged on. Make sure your user name and password are correct, and then try again.");
    }

    $txt = decode_entities ($txt);

    $errordoc = "<script type='text/javascript'>alert ('$txt');</script>\n";
}

my $untext = __("Username");
my $pwtext = __("Password");

my $txt1 = __("Please use Microsoft Internet Explorer (> 6.0) or Firefox (> 1.5) for full functionality.");
my $txt2 = __("JavaScript is active: ok.");
my $txt3 = __("JavaScript is not available. Please activate it in your browser configuration.");

my $css = '/css/pve.css';
my $customhref = "http://www.proxmox.com";
 
my $form = <<HERE;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>

<!-- Head Information -->
<head>
  <title>Proxmox Virtual Environment</title>
  <meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
  <LINK REL="stylesheet" type="text/css" HREF="$css">
</head>


<!-- Body start -->
<body style="margin:0px;padding:0px;margin=0px" onLoad="document.forms[0].credential_0.focus();">
$errordoc
<form name="frm" method="POST" action="/nrd/LOGIN" accept-charset="UTF-8">
<INPUT TYPE=hidden NAME=destination VALUE="$uri">
<!--Logo Block -->

<div align=center>

<table border=0 cellspacing=0 cellpadding=2 style="width:1000px;">
<tr class="boxheadline"><td colspan=3 align=right style="padding-right:5px;">&nbsp;</td></tr>
<tr class="boxheadline menubg"><td colspan=3 style="padding:0px;"><a href="$customhref" target="_blank"> 
    <img alt="" style="display:block;border:0px;width:1000px;max-height:300px;" src='/images/logo_pve.jpg'>
    </a></td>
</tr>
<tr class="boxheadline">
    <td align=left style="width:30%;padding-left:5px;">&nbsp;</td>
    <td align=center style="width:40%;padding-left:5px;">
      <a href='http://www.proxmox.com' target='_blank' class="boxheadline">Proxmox Virtual Environment $pvever</a>
    </td>
    <td align=right style="width:30%;padding-right:5px;">
      <a href='http://www.proxmox.com' target='_blank' class="boxheadline">www.proxmox.com</a>&nbsp;
    </td>
</tr>
</table>
<br>
</div>

<table width="100%" style="margin-top:100px;">
<tr>
  <td align="center">

  <!-- Login Window -->
  <table width=200 border=0 cellspacing=0 cellpadding=0>
    <tr class="boxheadline">
        <td colspan=2 align="left" style="padding:2px;padding-left:5px;">Login</td>
    </tr>
    <tr><td colspan=2 class="menubg" style="height:2px;"></td></tr>
    <tr>
        <td class="highlightbg"><img alt='' src="/images/blank.gif" width=5></td>
        <td class="menubg" style="width:195px;">
        <p style="margin:10px; text-align:center">
        <b class="hlfont">$untext:</b><br>
        <input name="credential_0" type="text" class="stdcolbd" style="width:145px;border:solid 1px;"><br><br>
        <b class="hlfont">$pwtext:</b><br>
        <input name="credential_1" type="password" class="stdcolbd" style="width:145px;border:solid 1px;"><br><br>
        <input type="submit" value="Login" class="stdcolbd hlfont" style="width:60px;border:solid 1px;"></p>
        </td>
    </tr>
   
    <tr><td>&nbsp;</td></tr>
    
    <tr class="boxheadline">
        <td colspan=2 align="left" style="padding:2px;padding-left:5px;">Information</td>
    </tr>
    <tr>
        <td colspan=2 style="width:200px;padding:10px;" align="left">
            <p style="margin:0px; font-size:9px;">$txt1<br><br>
            <script type="text/javascript"><!-- 
            document.write("$txt2");
            document.write("<span style='visibility:hidden; color:#FFFFFF; size:1px;'>"); 
            --></script>
            <b class="highlightfg">$txt3</b> 
            </p>
        </td>
    </tr>
    
  </table>
  
  </td>
</tr>

</table>
</form>
</body>
</html>
HERE


send_output ($r, $form);
exit (0);
